.include "bullet.h.s"
.include "entity.h.s"

.area _DATA
;;=====
;; Entity definitions
;;=====
defineEntity playerbullet, #map_margin_left+spaceship_width, #80, #1, #0, #bullet_width, #bullet_height, #_pre_ally_bullet, #0 ,#0, #0		;; Create player bullet
defineEntity playerbullet1, #map_margin_left+spaceship_width, #80, #1, #0, #bullet_width, #bullet_height, #_pre_ally_bullet, #0 ,#0, #0		;; Create player bullet
defineEntity playerbullet2, #map_margin_left+spaceship_width, #80, #1, #0, #bullet_width, #bullet_height, #_pre_ally_bullet, #0 ,#0, #0		;; Create player bullet

defineEntity enemybullet, #80-map_margin_left-spaceship_width, #80, #-1, #0, #bullet_width, #bullet_height, #_pre_enemy_bullet, #0, #0, #0	;; Create enemy bullet 
defineEntity enemybullet1, #80-map_margin_left-spaceship_width, #80, #-1, #0, #bullet_width, #bullet_height, #_pre_enemy_bullet, #0, #0, #0	;; Create enemy bullet 
defineEntity enemybullet2, #80-map_margin_left-spaceship_width, #80, #-1, #0, #bullet_width, #bullet_height, #_pre_enemy_bullet, #0, #0, #0	;; Create enemy bullet 

.area CODE
;;================;;
;;Public Functions;;
;;================;;
;;=====
;; Update the bullet
;; destroys: AF
;; inputs:
;; 		IX=>pointer to the bullet data
;;=====
bullet_update::
	ld a, Ent_a(ix) 		 				;; A=entity_active
	cp #0									;; check if playerbullet is active
	jr z, not_update 						;; if(active==0) not draw
		call move_x
	not_update:
ret

;;=====
;; Restart the player bullet
;; destroys: AF
;; inputs:
;; 		IX=>pointer to the player bullet data
;;=====
playerbullet_restart::
	ld a, Ent_x(ix) 						;; A=playerbullet_x
	cp #80-bullet_width-map_margin_right 	;; Check if playerbullet_x is on the left limit
	jr nz, no_restart						;; if(playerbullet_x==79) then playerbullet_x=6
		call set_innactive					;; change playerbullet_active to 0

	no_restart:

ret

;;=====
;; Restart the enemy bullet
;; destroys: AF
;; inputs:
;; 		IX=>pointer to the enemy bullet data
;;=====

enemybullet_restart::
	ld a, Ent_x(ix) 						;; A=playerbullet_x
	cp #map_margin_left 					;; Check if playerbullet_x is on the left limit
	jr nz, not_restart						;; if(playerbullet_x==79) then playerbullet_x=6
		call set_innactive					;; change playerbullet_active to 0

	not_restart:

ret

;;=====
;; Draw the bullet
;; destroys: IX
;;=====
bullet_draw::
	ld a, (playerbullet_active)					;; A=playerbullet_active
	cp #0 										;; Check if is active
	jr z, not_draw 								;; if(active==0) not draw
		ld ix, #playerbullet_data 				;; ix points playerbullet_data
		call drawentity							;; Draw our playerbullet

	not_draw:
	
	ld a, (playerbullet1_active)				;; A=playerbullet1_active
	cp #0 										;; Check if is active
	jr z, not_draw1 							;; if(active==0) not draw
		ld ix, #playerbullet1_data 				;; ix points playerbullet1_data
		call drawentity							;; Draw our playerbullet1

	not_draw1:

	ld a, (playerbullet2_active)				;; A=playerbullet2_active
	cp #0 										;; Check if is active
	jr z, not_draw2 							;; if(active==0) not draw
		ld ix, #playerbullet2_data 				;; ix points playerbullet2_data
		call drawentity							;; Draw our playerbullet2

	not_draw2:

	ld a, (enemybullet_active)					;; A=enemybullet_active
	cp #0 										;; Check if is active
	jr z, not_draw3 							;; if(active==0) not draw
		ld ix, #enemybullet_data 				;; ix points enemybullet_data
		call drawentity							;; Draw our enemybullet

	not_draw3:

	ld a, (enemybullet1_active)					;; A=enemybullet1_active
	cp #0 										;; Check if is active
	jr z, not_draw4 							;; if(active==0) not draw
		ld ix, #enemybullet1_data 				;; ix points enemybullet1_data
		call drawentity							;; Draw our enemybullet1

	not_draw4:

	ld a, (enemybullet2_active)					;; A=enemybullet2_active
	cp #0 										;; Check if is active
	jr z, not_draw5 							;; if(active==0) not draw
		ld ix, #enemybullet2_data 				;; ix points enemybullet2_data
		call drawentity							;; Draw our enemybullet2

	not_draw5:
ret

;;=====
;; Erase the bullet
;; destroys: IX
;;=====
bullet_erase::
	ld ix, #playerbullet_data				;; IX points to the data
	call eraseentity						;; Erase our playerbullet

	ld ix, #playerbullet1_data				;; IX points to the data
	call eraseentity						;; Erase our playerbullet1

	ld ix, #playerbullet2_data				;; IX points to the data
	call eraseentity						;; Erase our playerbullet2

	ld ix, #enemybullet_data				;; IX points to the data
	call eraseentity						;; Erase our enemybullet

	ld ix, #enemybullet1_data				;; IX points to the data
	call eraseentity						;; Erase our enemybullet1

	ld ix, #enemybullet2_data				;; IX points to the data
	call eraseentity						;; Erase our enemybullet2
ret

;;=====
;; Gets a pointer to enemybullet data in IX
;; destroys: IX
;; returns:
;; 		IX: pointer to enemybullet data
;;=====
enemybullet_getPtIX::
	ld ix, #enemybullet_data				;;IX=enemybullet_x
ret

;;=====
;; Gets a pointer to enemybullet1 data in IX
;; destroys: IX
;; returns:
;; 		IX: pointer to enemybullet1 data
;;=====
enemybullet1_getPtIX::
	ld ix, #enemybullet1_data				;;IX=enemybullet1_x
ret

;;=====
;; Gets a pointer to enemybullet2 data in IX
;; destroys: IX
;; returns:
;; 		IX: pointer to enemybullet2 data
;;=====
enemybullet2_getPtIX::
	ld ix, #enemybullet2_data				;;IX=enemybullet2_x
ret

;;=====
;; Gets a pointer to enemybullet data in IY
;; destroys: IY
;; returns:
;; 		IY: pointer to enemybullet data
;;=====
enemybullet_getPtIY::
	ld iy, #enemybullet_data				;;IY=enemybullet_x
ret

;;=====
;; Gets a pointer to enemybullet1 data in IY
;; destroys: IY
;; returns:
;; 		IY: pointer to enemybullet1 data
;;=====
enemybullet1_getPtIY::
	ld iy, #enemybullet1_data				;;IY=enemybullet1_x
ret

;;=====
;; Gets a pointer to enemybullet2 data in IY
;; destroys: IY
;; returns:
;; 		IY: pointer to enemybullet2 data
;;=====
enemybullet2_getPtIY::
	ld iy, #enemybullet2_data				;;IY=enemybullet2_x
ret

;;=====
;; Gets a pointer to playerbullet data in IX
;; destroys: IX
;; returns:
;; 		IX: pointer to playerbullet data
;;=====
playerbullet_getPtIX::
	ld ix, #playerbullet_data				;;IX=playerbullet_x
ret

;;=====
;; Gets a pointer to playerbullet1 data in IX
;; destroys: IX
;; returns:
;; 		IX: pointer to playerbullet1 data
;;=====
playerbullet1_getPtIX::
	ld ix, #playerbullet1_data				;;IX=playerbullet1_x
ret

;;=====
;; Gets a pointer to playerbullet2 data in IX
;; destroys: IX
;; returns:
;; 		IX: pointer to playerbullet2 data
;;=====
playerbullet2_getPtIX::
	ld ix, #playerbullet2_data				;;IX=playerbullet2_x
ret