.include "enemy.h.s"
.include "entity.h.s"
.include "panel.h.s"
.include "spaceship.h.s"

.area _DATA
;;=====
;; Entity definitions
;;=====
defineEntity enemy, #80-8-map_margin_right, #80, #-1, #1, #spaceship_width, #spaceship_height, #_pre_enemy_spaceship, #0, #10, #0	;; Create enemy
defineEntity enemy1, #80-8-map_margin_right, #50, #-1, #1, #spaceship_width, #spaceship_height, #_pre_enemy_spaceship, #0, #10, #0	;; Create enemy

enemy_timer_create: .db #90 			;; timer for create an enemy

enemy_move_timer: .db #10

.area _CODE
;;================;;
;;Public Functions;;
;;================;;
;;=====
;; Update the enemy
;; destroys: 
;;=====
enemy_update::
	ld a, Ent_a(ix) 					;; A=entity_active
	cp #0 								;; check if the enemy is active
	jr z, not_update 					;; if(active==0) not update

		call moveenemy 					;; move the enemy
		ld a, Ent_ts(iy) 				;; A=Ent_ts(iy)
		cp #0 							;; check if it is time to shoot
		jr nz, not_shoot 				;; if Ent_ts(iy)==0 not shoot
			call enemy_shoot 			;; shoot
			ld a, #60 					;; A=60
			ld Ent_ts(iy), a 			;; update Ent_ts(iy)
			ret

		not_shoot:

		dec a 							;; Ent_ts(iy)--
		ld Ent_ts(iy), a 				;; update Ent_ts(iy)

	not_update:
ret

;;=====
;; Draw all enemies
;; destroys: 
;;=====
enemy_draw::
	ld a, (enemy_active) 				;; A=enemy_active
	cp #0 								;; Check if is active
	jr z, not_draw 						;; if(active==0) not draw
		ld ix, #enemy_data 				;; ix points enemy_data
		call drawentity					;; Draw our enemy

	not_draw:

	ld a, (enemy1_active) 				;; A=enemy1_active
	cp #0 								;; Check if is active
	jr z, not_draw1 					;; if(active==0) not draw
		ld ix, #enemy1_data 			;; ix points enemy1_data
		call drawentity					;; Draw our enemy1

	not_draw1:
ret

;;=====
;; Explode all enemies
;; destroys: AF, IX
;;=====
enemy_explosion::
	ld a, (enemy_explosion_stage) 		;; A=enemy_explosion_stage
    cp #7 								;; check if asteroid is axploding
    jp z, finished 						;; if enemy_explosion_stage==7, no explode
		ld ix, #enemy_data				;; IX points to the data
		call draw_explosion				;; explode enemy
	finished:

	ld a, (enemy1_explosion_stage) 		;; A=enemy1_explosion_stage
    cp #7 								;; check if asteroid is axploding
    jp z, finished1						;; if enemy1_explosion_stage==7, no explode
		ld ix, #enemy1_data				;; IX points to the data
		call draw_explosion				;; explode enemy1
	finished1:

	ret

;;=====
;; Gets a pointer to enemy data in IX
;; destroys: IX
;; returns:
;; 		IX: pointer to enemy data
;;=====
enemy_getPtIX::
	ld ix, #enemy_data					;;IX=enemy_data
ret

;;=====
;; Gets a pointer to enemy1 data in IX
;; destroys: IX
;; returns:
;; 		IX: pointer to enemy1 data
;;=====
enemy1_getPtIX::
	ld ix, #enemy1_data					;;IX=enemy1_data
ret


;;=====
;; Gets a pointer to enemy data in IY
;; destroys: IY
;; returns:
;; 		IY: pointer to enemy data
;;=====
enemy_getPtIY::
	ld iy, #enemy_data					;;IY=enemy_data
ret

;;=====
;; Gets a pointer to enemy1 data in IY
;; destroys: IY
;; returns:
;; 		IY: pointer to enemy1 data
;;=====
enemy1_getPtIY::
	ld iy, #enemy1_data					;;IY=enemy1_data
ret

;;=====
;; Check if there is any enemy innactive and, if there is, create a new one
;;=====
create_enemy::
	call getLevel
	cp #1
	jr z, dont_spawn 						;; Dont spawn if you are yet at level 1

		ld a, (enemy_timer_create) 			;; A=enemy_timer_create
		cp #0 								;; Check if it is time to create a new enemy
		jr nz, not_create_at_all			;;

			ld a, (enemy_active)			;; A=enemy_active
			cp #1 							;; Check if enemy is active
			jr z, not_create_0 				;; If is active, not create
			ld a, (enemy_explosion_stage)
			cp #7
			jr nz, not_create_0

				call enemy_getPtIX
				call restart_enemy 			;; restart enemy
				call set_active 			;; active enemy
				ret

			not_create_0:
				ld a, (enemy1_active)		;; A=enemy1_active
				cp #1 						;; Check if enemy1 is active
				jr z, not_create_1 			;; If is active, not create
				ld a, (enemy1_explosion_stage)
				cp #7
				jr nz, not_create_1

					call enemy1_getPtIX 	;; IX=enemy1_data
					call restart_enemy	 	;; restart enemy1
					call set_active 		;; active enemy1
					ret

				not_create_1:
					ret

				not_create_at_all:
					ld a, (enemy_timer_create) 	;; A=enemy_timer_create
					dec a 						;; enemy_timer_create
					ld (enemy_timer_create), a 	;; update enemy_timer_create

	dont_spawn:

ret

;;=====
;; Set values of enemy to the original values
;; destroys: AF
;; input:
;; 		IX => enemy data
;;=====
;;ToDo: no debe hacerse hasta que acabe la animacion de explosion
restart_enemy::
	call set_innactive 					;; set enemy innactive
	ld a, #80-8-map_margin_right 		;; a=original position x of enemy
	call set_x							;; set position x
	call _getRandomLimitedNumber 		;; get random number for position y of enemy
	ld a, l 							
	call set_y 							;; set position y
	ld a, #1 							;; a=orininal direction in y of enemy
	ld Ent_dy(ix), a 					;; update direction y of enemy
	ld a, (enemy_move_timer) 			;; reset timer to move enemy
	ld Ent_t(ix), a 					;; update the timer to move enemy
	ld a, #0 							;; reset timer to shoot of enemy
	ld Ent_ts(ix), a 					;; update timer to shoot of enemy
	ld a, #90 							;; reset timer to create a new enemy
	ld (enemy_timer_create), a 			;; update timer to create a new enemy
ret

;;=================;;
;;Private Functions;;
;;=================;;
;;=====
;; Moves the enemy
;; destroys: AF
;; inputs:
;; 		IX => pointer to enemy data
;;=====
moveenemy:
	ld a, Ent_y(ix) 					;; A=enemy_y
	cp #map_margin_top					;; Check against top limit
	jr nz, do_not_change_to_1 			;; enemy_y != limit

		;; change to 1 enemy_d
		ld a, #1						;; A=1
		ld Ent_dy(ix), a 				;; enemy_d=A

	do_not_change_to_1:
	
	cp #450-spaceship_height-map_margin_bottom	;; Check against bottom limit
	jr nz, do_not_change_to_minus1		;; enemy_y != limit

		;; change to -1 enemy_d
		ld a, #-1						;; A=1
		ld Ent_dy(ix), a 				;; enemy_d=A

	do_not_change_to_minus1:
	
	call move_y

	ld a, Ent_t(ix)						;; A=enemy_timer
	cp #0 								;; Check if it's time to move left
	jr nz, do_not_move_left				;; enemy_timer != 0

		;;move_left
		ld a, Ent_x(ix)					;; A=enemy_x
		cp #2+map_margin_left 			;; Check with left limit
		jr z, not_move 					;; if it is on the left limit, do not move

			call move_x

			ld a, (enemy_move_timer) 	;; reset enemy_timer
			dec a 						;; enemy_timer--
			ld Ent_t(ix), a 			;; update enemy_timer
			
			ret

		not_move:

			call eraseentity
			call refresh_last_x
			call refresh_last_y
			call eraseentity

			call toggleVideoMemory

			call eraseentity
			call refresh_last_x
			call refresh_last_y
			call eraseentity

			call toggleVideoMemory

			call decrease_hp
			call draw_hp_simple
			call set_damaged_0

			call set_innactive 				;; enemy_active=0
		ret


	do_not_move_left:
	dec a 								;; enemy_timer--
	ld Ent_t(ix), a 					;; update enemy_timer
ret

;;=====
;; Check if there is any enemybullet innactive and, if there is, shoots
;; destroys: IX, AF
;; Input:
;; 		IY => Enemy_data
;;=====
enemy_shoot:
	call enemybullet_getPtIX 			;; IX=enemybullet_data
	ld a, Ent_a(ix) 					;; A=enemybullet_active
	cp #1 								;; Check if the bullet is already active
	jr z, not_shoots_0 					;; if bullet active then not shoot
		ld a, Ent_x(iy)					;; A=enemy_x
		call set_x 						;; update enemybullet_x
		ld a, Ent_y(iy)					;; A=enemy_y
		call set_y 						;; update enemybullet_y
		call refresh_last_y
		call set_active 				;; activate enemybullet
		ret
	not_shoots_0:
		call enemybullet1_getPtIX 		;; IX=enemybullet1_data
		ld a, Ent_a(ix) 				;; A=enemybullet1_active
		cp #1 							;; Check if the bullet is already active
		jr z, not_shoots_1 				;; if bullet active then not shoot
			ld a, Ent_x(iy)				;; A=enemy_x
			call set_x 					;; update enemybullet1_x
			ld a, Ent_y(iy)				;; A=enemy_y
			call set_y 					;; update enemybullet1_y
			call refresh_last_y
			call set_active 			;; activate enemybullet1
			ret
		not_shoots_1:
			call enemybullet2_getPtIX 	;; IX=enemybullet2_data
			ld a, Ent_a(ix) 			;; A=enemybullet2_active
			cp #1 						;; Check if the bullet is already active
			jr z, not_shoots_2 			;; if bullet active then not shoot
				ld a, Ent_x(iy)			;; A=enemy_x
				call set_x 				;; update enemybullet2_x
				ld a, Ent_y(iy)			;; A=enemy_y
				call set_y 				;; update enemybullet2_y
				call refresh_last_y
				call set_active 		;; activate enemybullet2
				ret
			not_shoots_2:
ret


;;================
;;================
;; DIFICULTY
;;================
;;================

;;========
;; INCREASES THE HORIZONTAL SPEED OF THE ENEMY
;; INPUT -> A = NEW SPEED
;;========
increase_enemy_speed:
		ld (enemy_move_timer), a
ret

;;========
;; INCREASES THE SPAWN SPEED OF THE ENEMY
;; INPUT -> A = NEW SPEED
;;========
increase_enemy_spawn:
		ld (enemy_timer_create), a
ret