.include "inputController.h.s"
.include "keyboard/keyboard.s"

.area _DATA
.area _CODE

;;================;;
;;Public Functions;;
;;================;;
;;=====
;; Checks user input and reacts
;; destroys: AF, HL
;;=====
checkSpaceshipInput:
	;; Check for key 'UP' being pressed
	ld hl, #Key_CursorUp 					;; HL=key_W keycode
	call cpct_isKeyPressed_asm  			;; check if key_W is pressed
	cp #0 									;; check if A==0
	jr z, w_not_pressed 					;; down if A==0 W is not pressed

		;; w is pressed
		call spaceship_moveup 				;; move spaceship up
		jr up_not_pressed					;; Avoid acting twice if both keyboard and joystick are being used at the same time
	
	w_not_pressed:

	;;Check for joystick INPUT

	ld hl, #Joy0_Up							;;
	call cpct_isKeyPressed_asm 				;;
	cp #0 									;; Check if joystick is tilted upwards
	jr z, up_not_pressed
		;;up is pressed
		call spaceship_moveup

	up_not_pressed:


	;; Check for key 'DOWN' being pressed
	ld hl, #Key_CursorDown 							;; HL=key_S keycode
	call cpct_isKeyPressed_asm    			;;check if key_S is pressed
	cp #0 									;; check if A==0
	jr z, s_not_pressed 					;; up if A==0 S is not pressed

		;; S is pressed 					
		call spaceship_movedown 			;; move spaceship down
		jr down_not_pressed					;; Avoid acting twice if both keyboard and joystick are being used at the same time
	
	s_not_pressed:

	;;Check for joystick INPUT

	ld hl, #Joy0_Down						;;
	call cpct_isKeyPressed_asm 				;;
	cp #0 									;; Check if joystick is tilted downwards
	jr z, down_not_pressed
		;;up is pressed
		call spaceship_movedown	

	down_not_pressed:

	;; Check for key 'Space' being pressed
	ld hl, #Key_Space 						;; HL=key_Space keycode
	call cpct_isKeyPressed_asm 				;; check if key_Space is pressed
	cp #0 									;; check if A==0
	jr z, space_not_pressed 				;; shoot if A==0 space is not pressed
		call spaceship_castbullet 			;; shoot
		jr fire_not_pressed				;; Avoid acting twice if both keyboard and joystick are being used at the same time
	
	space_not_pressed:

	;;Check for joystick INPUT

	ld hl, #Joy0_Fire1						;;
	call cpct_isKeyPressed_asm 				;;
	cp #0 									;; Check if fire button is pressed
	jr z, fire_not_pressed
		;;up is pressed
		call spaceship_castbullet

	fire_not_pressed:

ret

;;=====
;; Check for any key being pressed
;; destroys: AF, HL
;;=====
waitKey:
	call cpct_scanKeyboard_asm 				;; scan the keyboard
	key_not_pressed:
        call cpct_isAnyKeyPressed_f_asm    	;;check if any key is pressed
        cp #0 								;; check if A==0
	jr z, key_not_pressed 					;; up if A==0 S is not pressed
ret

;;=====
;; Check for key 'Escape' being pressed and released
;;=====

pressEscape:
	ld hl, #Key_Esc 						;; HL=key_Escape keycode
	call cpct_isKeyPressed_asm 				;; check if key_Escape is pressed
	cp #0 									;; check if A==0
	jr z, escape_not_pressed 				;; shoot if A==0 Escape is not pressed
		;; Escape pressed
		escape_not_released:
			call cpct_isAnyKeyPressed_f_asm    	;;check if any key is pressed
      		cp #0 								;; check if A==0
		jr nz, escape_not_released				;; up if A==0 S is not pressed
		call toggle_pause_menu
		ret
	
	escape_not_pressed:
ret