.include "panel.h.s"
.include "enemy.h.s"
.include "asteroid.h.s"
.include "entity.h.s"

.area _DATA
score: .dw #0
hp: .db #5

level:: .db #1
lvlup_timer: .db #0

pause_menu_bool: .db #0

value_score: .db #0x00, #0x00, #0x00, #0x00, #0x00, #0x00
value_hp: .db #0x00, #0x00, #0x00, #0x00

.area _CODE
;;================;;
;;Public Functions;;
;;================;;

draw_hp_simple:

    ld a, (buffer_start)
    ld d, a
    ld e, #0x00
    ld a, #hp_position_x
    ld c, a                             ;; C=entity x
    ld a, #hp_position_y       
    ld b, a                             ;; B=entity x
    call cpct_getScreenPtr_asm  ;; Get pointer to screen -> DE

    ex de, hl
    ld a, (hp)
    call get_number_sprite


    ld c, #4                              ;; C=entity w
    ld b, #8                              ;; B=entity h
    call cpct_drawSprite_asm

    call toggleVideoMemory

    ld a, (buffer_start)
    ld d, a
    ld e, #0x00
    ld a, #hp_position_x
    ld c, a                             ;; C=entity x
    ld a, #hp_position_y       
    ld b, a                             ;; B=entity x
    call cpct_getScreenPtr_asm  ;; Get pointer to screen -> DE

    ex de, hl
    ld a, (hp)
    call get_number_sprite


    ld c, #4                              ;; C=entity w
    ld b, #8                              ;; B=entity h
    call cpct_drawSprite_asm

    call toggleVideoMemory
ret


draw_level_text:
    ld a, (buffer_start)
    ld d, a
    ld e, #0x00
    ld a, #lvl_text_position_x
    ld c, a                             ;; C=entity x
    ld a, #lvl_text_position_y       
    ld b, a                             ;; B=entity x
    call cpct_getScreenPtr_asm  ;; Get pointer to screen -> DE

    ex de, hl
    ld hl, #_pre_lvl            ;; HL=sprite pointer


    ld c, #11                              ;; C=entity w
    ld b, #8                              ;; B=entity h
    call cpct_drawSprite_asm

    call toggleVideoMemory

    ld a, (buffer_start)
    ld d, a
    ld e, #0x00
    ld a, #lvl_text_position_x
    ld c, a                             ;; C=entity x
    ld a, #lvl_text_position_y       
    ld b, a                             ;; B=entity x
    call cpct_getScreenPtr_asm  ;; Get pointer to screen -> DE

    ex de, hl
    ld hl, #_pre_lvl            ;; HL=sprite pointer


    ld c, #11                              ;; C=entity w
    ld b, #8                              ;; B=entity h
    call cpct_drawSprite_asm

    call toggleVideoMemory
ret


draw_level_simple:

    ld a, (buffer_start)
    ld d, a
    ld e, #0x00
    ld a, #lvl_position_x
    ld c, a                             ;; C=entity x
    ld a, #lvl_position_y       
    ld b, a                             ;; B=entity x
    call cpct_getScreenPtr_asm  ;; Get pointer to screen -> DE

    ex de, hl
    ld a, (level)
    call get_number_sprite


    ld c, #4                              ;; C=entity w
    ld b, #8                              ;; B=entity h
    call cpct_drawSprite_asm

    call toggleVideoMemory

    ld a, (buffer_start)
    ld d, a
    ld e, #0x00
    ld a, #lvl_position_x
    ld c, a                             ;; C=entity x
    ld a, #lvl_position_y       
    ld b, a                             ;; B=entity x
    call cpct_getScreenPtr_asm  ;; Get pointer to screen -> DE

    ex de, hl
    ld a, (level)
    call get_number_sprite


    ld c, #4                              ;; C=entity w
    ld b, #8                              ;; B=entity h
    call cpct_drawSprite_asm

    call toggleVideoMemory
ret

show_lvl_up:
    ld a, (lvlup_timer)
    cp #0
    jp z, dont_show_lvlup
        cp #1
        jp z, erase_lvlup
        cp #2
        jp z, erase_lvlup
            ld a, (buffer_start)
            ld d, a
            ld e, #0x00
            ld a, #lvlup_position_x
            ld c, a                             ;; C=entity x
            ld a, #lvlup_position_y       
            ld b, a                             ;; B=entity x
            call cpct_getScreenPtr_asm          ;; Get pointer to screen -> DE

            ex de, hl
            ld hl, #_pre_lvlup                  ;; HL=sprite pointer
            ld c, #27                           ;; C=entity w
            ld b, #8                            ;; B=entity h
            call cpct_drawSprite_asm

            ld a, (lvlup_timer)
            dec a
            ld (lvlup_timer), a
        ret

        erase_lvlup:
            ld a, (buffer_start)
            ld d, a
            ld e, #0x00
            ld a, #lvlup_position_x
            ld c, a                             ;; C=entity x
            ld a, #lvlup_position_y       
            ld b, a                             ;; B=entity x
            call cpct_getScreenPtr_asm          ;; Get pointer to screen -> DE

            ex de, hl
            ld a, #0x00							;; A=backgroundcolor
            ld c, #27                           ;; C=entity w
            ld b, #8                            ;; B=entity h
            call cpct_drawSolidBox_asm

            ld a, (lvlup_timer)
            dec a
            ld (lvlup_timer), a
        ret

    dont_show_lvlup:
ret

;;==========
;;  SIMPLY DRAW A NUMBER 
;;  INPUT -> A = VALUE 
;;           DE = SCREEN POINTER  
;;  DESTROYS: wHATEVER DRAWSPRITE NEEDS
;;==========
get_number_sprite:
    
    cp #0
    jr nz, not_zero
        ld hl, #_numbers_numbers_00     ;; HL=sprite pointer
        jr number_chosen
    not_zero:

    cp #1
    jr nz, not_one
        ld hl, #_numbers_numbers_01     ;; HL=sprite pointer
        jr number_chosen

    not_one:
    cp #2
    jr nz, not_two
        ld hl, #_numbers_numbers_02     ;; HL=sprite pointer
        jr number_chosen

    not_two:
    cp #3
    jr nz, not_three
        ld hl, #_numbers_numbers_03     ;; HL=sprite pointer
        jr number_chosen

    not_three:
    cp #4
    jr nz, not_four
        ld hl, #_numbers_numbers_04     ;; HL=sprite pointer
        jr number_chosen

    not_four:
        ld hl, #_numbers_numbers_05     ;; HL=sprite pointer

    number_chosen:
ret

;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;SCORE;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;
;;Draw the string
show_score_text:
	ld a, (buffer_start)
	ld d, a
	ld e, #0x00
    ld a, #score_text_position_x
    ld c, a		                        ;; C=entity x
    ld a, #score_text_position_y		
    ld b, a		                        ;; B=entity x
    call cpct_getScreenPtr_asm          ;; Get pointer to screen -> DE

    ex de, hl
    ld hl, #_pre_score	                ;; HL=sprite pointer
    ld c, #20				            ;; C=entity w
    ld b, #8				            ;; B=entity h
    call cpct_drawSprite_asm
ret 

;;Draw the score
show_score:
	ld a, (buffer_start)
	ld d, a
	ld e, #0x00
    ld a, #score_position_x
    ld c, a		                        ;; C=entity x
    ld a, #score_position_y
    ld b, a		                        ;; B=entity x
    call cpct_getScreenPtr_asm          ;; Get pointer to screen -> DE

    ex de, hl
    push de
    
    ld hl, (score)
    ld de, #value_score
    call HL_2_ASCII
    ld bc, #value_score
    pop de
    ld a, #5
    number_loop:
        push af
            ld a, (bc)
            call drawNumber
            inc bc
            ld hl, #4
            add hl, de
            ex de, hl
        pop af
        dec a
        cp #0
    jr nz, number_loop

    call toggleVideoMemory

    ld a, (buffer_start)
    ld d, a
    ld e, #0x00
    ld a, #score_position_x
    ld c, a                             ;; C=entity x
    ld a, #score_position_y
    ld b, a                             ;; B=entity x
    call cpct_getScreenPtr_asm          ;; Get pointer to screen -> DE

    ex de, hl
    push de
    
    ld hl, (score)
    ld de, #value_score
    call HL_2_ASCII
    ld bc, #value_score
    pop de
    ld a, #5
    number_loop1:
        push af
            ld a, (bc)
            call drawNumber
            inc bc
            ld hl, #4
            add hl, de
            ex de, hl
        pop af
        dec a
        cp #0
    jr nz, number_loop1

    call toggleVideoMemory
ret

;;refresh_score:
;;    ld a, (score_bool)
;;    cp #1
;;    jp nz, dont_score_bool
;;        call show_score                    ;; Shows the score 
;;        ld a, #0
;;        ld (score_bool), a
;;    dont_score_bool:
;;ret

increase_score:
    ld hl, (score)
    ld bc, #10
    add hl, bc
    ld (score), hl

    ld a, (level)
    cp #5
    jr z, max_level                         ;; Dont ioncrease difficulty if you are already at max level
        call increase_difficulty
    max_level:
ret

;;change_score:
;;    ld a, #1
;;    ld (score_bool), a
;;ret





;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;HP;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;
;;Draw the string
show_hp_text:
	ld a, (buffer_start)
	ld d, a
	ld e, #0x00
    ld a, #hp_text_position_x
    ld c, a		                        ;; C=entity x
    ld a, #hp_text_position_y		
    ld b, a		                        ;; B=entity x
    call cpct_getScreenPtr_asm  ;; Get pointer to screen -> DE

    ex de, hl
    ld hl, #_pre_ally_spaceship            ;; HL=sprite pointer
    ld c, #8				               ;; C=entity w
    ld b, #16				               ;; B=entity h
    call cpct_drawSprite_asm
ret



;;Draw the score
show_hp:
	ld a, (buffer_start)
	ld d, a
	ld e, #0x00
    ld a, #hp_position_x
    ld c, a		                        ;; C=entity x
    ld a, #hp_position_y
    ld b, a		                        ;; B=entity x
    call cpct_getScreenPtr_asm  ;; Get pointer to screen -> DE

    ex de, hl
    push de
    
    ld a, (hp)
    ld de, #value_hp
    call A_2_ASCII
    ld bc, #value_hp
    pop de
    ld a, #3
    number_loop_hp:
        push af
            ld a, (bc)
            call drawNumber
            inc bc
            ld hl, #4
            add hl, de
            ex de, hl
        pop af
        dec a
        cp #0
    jr nz, number_loop_hp

    call toggleVideoMemory

    ld a, (buffer_start)
    ld d, a
    ld e, #0x00
    ld a, #hp_position_x
    ld c, a                             ;; C=entity x
    ld a, #hp_position_y
    ld b, a                             ;; B=entity x
    call cpct_getScreenPtr_asm  ;; Get pointer to screen -> DE

    ex de, hl
    push de
    
    ld a, (hp)
    ld de, #value_hp
    call A_2_ASCII
    ld bc, #value_hp
    pop de
    ld a, #3
    number_loop_hp1:
        push af
            ld a, (bc)
            call drawNumber
            inc bc
            ld hl, #4
            add hl, de
            ex de, hl
        pop af
        dec a
        cp #0
    jr nz, number_loop_hp1

    call toggleVideoMemory
ret

;;refresh_hp:
;;    ld a, (hp_bool)
;;    cp #1
;;    jp nz, dont_hp_bool
;;        call show_hp    			        ;; Shows the hp 
;;        ld a, #0
;;        ld (hp_bool), a
;;    dont_hp_bool:
;;ret

decrease_hp:
    ld a, (hp)
    dec a
    ld (hp), a
    call z, game_over 
ret

;;change_hp:
;;    ld a, #1
;;    ld (hp_bool), a
;;ret

;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;LOGO;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;
show_logo:
    ;;Draw the logo
	ld a, (buffer_start)
	ld d, a
	ld e, #0x00
    ld a, #logo_position_x
    ld c, a		                        ;; C=entity x
    ld a, #logo_position_y		
    ld b, a		                        ;; B=entity x
    call cpct_getScreenPtr_asm  ;; Get pointer to screen -> DE
    ex de, hl
    ld hl, #_pre_logo ;; HL=sprite pointer
    ld c, #25				    ;; C=entity w
    ld b, #23				    ;; B=entity h
    call cpct_drawSprite_asm
ret

;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;GAME OVER;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;

game_over:
    call initializeVideoMemory

    ld a, (buffer_start)
    ld d, a
    ld e, #0x00
    ld c, #8				               ;; C=entity_x
    ld b, #15				               ;; B=entity_y
    call cpct_getScreenPtr_asm             ;; Get pointer to screen

    ;; Draw a sprite
    ex de, hl 					           ;; DE points to screen
    ld hl, #_pre_game_over		           ;; HL=sprite pointer
    ld c, #63  		        	           ;; C=entity_w
    ld b, #184  				           ;; B=entity_h
    call cpct_drawSprite_asm

    call toggleVideoMemory

    ld a, (buffer_start)
    ld d, a
    ld e, #0x00
    ld c, #8				               ;; C=entity_x
    ld b, #15				               ;; B=entity_y
    call cpct_getScreenPtr_asm             ;; Get pointer to screen

    ;; Draw a sprite
    ex de, hl 					           ;; DE points to screen
    ld hl, #_pre_game_over		           ;; HL=sprite pointer
    ld c, #63  		        	           ;; C=entity_w
    ld b, #184 				               ;; B=entity_h
    call cpct_drawSprite_asm

    call toggleVideoMemory

    ld a, #100

    ;;========================
    ;; SHOW SCORE ON GAME OVER SCREEN
    ;;========================

    ld a, (buffer_start)
    ld d, a
    ld e, #0x00
    ld a, #29
    ld c, a                             ;; C=entity x
    ld a, #40
    ld b, a                             ;; B=entity x
    call cpct_getScreenPtr_asm          ;; Get pointer to screen -> DE

    ex de, hl
    push de
    
   

    ld hl, (score)
    ld de, #value_score
    call HL_2_ASCII
    ld bc, #value_score
    pop de
    ld a, #5
    number_loop0:
        push af
            ld a, (bc)
            call drawNumber
            inc bc
            ld hl, #4
            add hl, de
            ex de, hl
        pop af
        dec a
        cp #0
    jr nz, number_loop0

    call toggleVideoMemory

    ld a, (buffer_start)
    ld d, a
    ld e, #0x00
    ld a, #40
    ld c, a                             ;; C=entity x
    ld a, #46
    ld b, a                             ;; B=entity x
    call cpct_getScreenPtr_asm          ;; Get pointer to screen -> DE

    ex de, hl
    push de
    
    ld hl, (score)
    ld de, #value_score
    call HL_2_ASCII
    ld bc, #value_score
    pop de
    ld a, #5
    number_loop11:
        push af
            ld a, (bc)
            call drawNumber
            inc bc
            ld hl, #4
            add hl, de
            ex de, hl
        pop af
        dec a
        cp #0
    jr nz, number_loop11

    call toggleVideoMemory

    ;;========================
    ;; SHOW SCORE ON GAME OVER SCREEN
    ;;========================

    call sleep

    call waitKey

    ld a, #5                                ;; restart spaceship HP
    ld (hp), a                              ;; update spaceship HP
    ld hl, #0                               ;; restart score
    ld (score), hl                          ;; update score
    call restart_spaceship                  ;; restart spaceship values
    call enemy_getPtIX                      ;; IX points to enemy data
    call restart_enemy                      ;; restart enemy values
    call enemy1_getPtIX                     ;; IX points to enemy1 data
    call restart_enemy                      ;; restart enemy1 values
    call playerbullet_getPtIX               ;; IX points to playerbullet data
    call set_innactive                      ;; set playerbullet innactive
    call playerbullet1_getPtIX              ;; IX points to playerbullet1 data
    call set_innactive                      ;; set playerbullet1 innactive
    call playerbullet2_getPtIX              ;; IX points to playerbullet2 data
    call set_innactive                      ;; set playerbullet2 innactive
    call enemybullet_getPtIX                ;; IX points to enemybullet data
    call set_innactive                      ;; set enemybullet innactive
    call enemybullet1_getPtIX               ;; IX points to enemybullet1 data
    call set_innactive                      ;; set enemybullet1 innactive
    call enemybullet2_getPtIX               ;; IX points to enemybullet2 data
    call set_innactive                      ;; set enemybullet2 innactive
    call asteroid_getPtIX                   ;; IX points to asteroid
    call restart_asteroid                   ;; restart asteroid values
    call asteroid1_getPtIX                  ;; IX points to asteroid1
    call restart_asteroid                   ;; restart asteroid1 values
    call asteroid2_getPtIX                  ;; IX points to asteroid2
    call restart_asteroid                   ;; restart asteroid2 values

    ;;Restart difficulty
    ld a, #10
    call increase_enemy_speed
    ld a, #15
    call increase_asteroid_speed
    ld a, #90
    call increase_enemy_spawn
    ld a, #120
    call increase_asteroid_spawn

    ;; REstart the level
    ld a, #1
    ld (level), a

    call newgame
ret

;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;PAUSE MENU;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;
pause_menu_listener:
    show_menu:
        ld a, (pause_menu_bool)
        cp #0
        jp z, dont_show_menu
            call pressEscape
    jr show_menu
    dont_show_menu:
ret

show_pause_menu:
    ld a, (buffer_start)
    ld d, a
    ld e, #0x00
    ld c, #pause_menu_x				    ;; C=entity_x
    ld b, #pause_menu_y				    ;; B=entity_y
    call cpct_getScreenPtr_asm  ;; Get pointer to screen

    ;; Draw a sprite
    ex de, hl 					;; DE points to screen
    ld hl, #_pre_pause	    ;; HL=sprite pointer
    ld c, #17				;; C=entity w
    ld b, #8				;; B=entity h

    call cpct_drawSprite_asm

    call toggleVideoMemory

    ld a, (buffer_start)
    ld d, a
    ld e, #0x00
    ld c, #pause_menu_x				    ;; C=entity_x
    ld b, #pause_menu_y				    ;; B=entity_y
    call cpct_getScreenPtr_asm  ;; Get pointer to screen

    ;; Draw a sprite
    ex de, hl 					;; DE points to screen
    ld hl, #_pre_pause		;; HL=sprite pointer
    ld c, #17				;; C=entity w
    ld b, #8				;; B=entity h
    call cpct_drawSprite_asm

    call toggleVideoMemory
ret

erase_pause_menu:
    ld a, (buffer_start)
    ld d, a
    ld e, #0x00
    ld c, #pause_menu_x				    ;; C=entity_x
    ld b, #pause_menu_y				    ;; B=entity_y
    call cpct_getScreenPtr_asm  ;; Get pointer to screen

    ;; Draw a sprite
    ex de, hl 				    ;; DE points to screen
	ld a, #0x00				;; A=backgroundcolor
    ld c, #20				;; C=entity w
    ld b, #8				;; B=entity h
	call cpct_drawSolidBox_asm

    call toggleVideoMemory

    ld a, (buffer_start)
    ld d, a
    ld e, #0x00
    ld c, #pause_menu_x				    ;; C=entity_x
    ld b, #pause_menu_y				    ;; B=entity_y
    call cpct_getScreenPtr_asm  ;; Get pointer to screen

    ;; Draw a sprite
    ex de, hl 					;; DE points to screen
    ld hl, #_pre_pause		;; HL=sprite pointer
	ld a, #0x00				;; A=backgroundcolor
    ld c, #17				;; C=entity w
    ld b, #8				;; B=entity h
	call cpct_drawSolidBox_asm

    call toggleVideoMemory

ret

toggle_pause_menu:
    ld a, (pause_menu_bool)
	cp #0
    jr z, is_0
        ;is 1
        ld a, #0
        ld (pause_menu_bool), a
        call erase_pause_menu
ret
    is_0:
        ld a, #1
        ld (pause_menu_bool), a
        call show_pause_menu
        call pause_menu_listener
ret

;;=================;;
;;Private Functions;;
;;=================;;
;;;;;;;;; AUXILIARES ;;;;;;;;;;
;;Recibe A con digito a mostrar en ascii
drawNumber:
    push af
    push bc
    push de
    push hl

    ld c, #4				                ;; C=entity w
    ld b, #8				                ;; B=entity h

    sbc a, #0x30
    jr nz, not_0
        push af
            ld hl, #_numbers_numbers_00     ;; HL=sprite pointer
            call cpct_drawSprite_asm
        pop af
        jp finish
    not_0:
    add a, #0x30

    sbc a, #0x31
    jr nz, not_1
        push af
            ld hl, #_numbers_numbers_01 	;; HL=sprite pointer
            call cpct_drawSprite_asm
        pop af
        jp finish
    not_1:
    add a, #0x31

    sbc a, #0x32
    jr nz, not_2
        push af
            ld hl, #_numbers_numbers_02 	;; HL=sprite pointer
            call cpct_drawSprite_asm
        pop af
        jp finish
    not_2:
    add a, #0x32

    sbc a, #0x33
    jr nz, not_3
        push af
            ld hl, #_numbers_numbers_03 	;; HL=sprite pointer
            call cpct_drawSprite_asm
        pop af
        jp finish
    not_3:
    add a, #0x33

    sbc a, #0x34
    jr nz, not_4
        push af
            ld hl, #_numbers_numbers_04 	;; HL=sprite pointer
            call cpct_drawSprite_asm
        pop af
        jp finish
    not_4:
    add a, #0x34

    sbc a, #0x35
    jr nz, not_5
        push af
            ld hl, #_numbers_numbers_05 	;; HL=sprite pointer
            call cpct_drawSprite_asm
        pop af
        jp finish
    not_5:
    add a, #0x35

    sbc a, #0x36
    jr nz, not_6
        push af
            ld hl, #_numbers_numbers_06 	;; HL=sprite pointer
            call cpct_drawSprite_asm
        pop af
        jp finish
    not_6:
    add a, #0x36

    sbc a, #0x37
    jr nz, not_7
        push af
            ld hl, #_numbers_numbers_07 	;; HL=sprite pointer
            call cpct_drawSprite_asm
        pop af
        jp finish
    not_7:
    add a, #0x37

    sbc a, #0x38
    jr nz, not_8
        push af
            ld hl, #_numbers_numbers_08 	;; HL=sprite pointer
            call cpct_drawSprite_asm
        pop af
        jp finish
    not_8:
    add a, #0x38

    sbc a, #0x39
    jr nz, not_9
        push af
            ld hl, #_numbers_numbers_09 	;; HL=sprite pointer
            call cpct_drawSprite_asm
        pop af
        jp finish
    not_9:
    add a, #0x39

    finish:
    pop hl
    pop de
    pop bc
    pop af
ret

;; Recible HL y devuelve en el puntero a DE
HL_2_ASCII:
    ld	bc, #-10000
	call	Num1
	ld	bc, #-1000
	call	Num1
	ld	bc, #-100
	call	Num1
	ld	c,  #-10
	call	Num1
	ld	c,b

    Num1:
        ld	a, #'0'-1
        Num2:
            inc	a
            add	hl,bc
        jr	c,Num2
        sbc	hl,bc

        ld	(de),a
        inc	de
ret

;; Recible A y devuelve en el puntero a DE
A_2_ASCII:
	ld	c,#-100
	call	Nm1
	ld	c,#-10
	call	Nm1
	ld	c,#-1
    Nm1:
        ld	b,#'0'-1
        Nm2:
            inc	b
	        add	a,c
	    jr	c,Nm2
	    sub	c		                        ;works as add 100/10/1
        
        push af		                        ;safer than ld c,a
            ld	a,b		                    ;char is in b
            ld	(de),a
            inc	de
        pop af		                        ;safer than ld a,c
	
ret

;;=====
;; INCREASE DIFFICULTY
;;=====
increase_difficulty::
    ld a, (score)
    cp #300
    jp nz, not_level_5                          ;;if score is higher then 300, level 5 -> faster enemies and asteroids
        ;;LEVEL 5

        ;;SPEED
        ld a, #4
        call increase_enemy_speed
        ld a, #3
        call increase_asteroid_speed

        ;;SPAWN
        ld a, #30
        call increase_enemy_spawn
        ld a, #30
        call increase_asteroid_spawn

        ld a, #5
        ld (level), a
        call draw_level_simple

        ld a, #lvl_up_timer
        ld (lvlup_timer), a

        ret

    not_level_5:
    cp #200
    jp nz, not_level_4                           ;;if score is higher then 200, level 4 -> faster enemies and asteroids
        ;; LEVEL 4

        ;;SPEED
        ld a, #6
        call increase_enemy_speed
        ld a, #7
        call increase_asteroid_speed

        ;;SPAWN
        ld a, #55
        call increase_enemy_spawn
        ld a, #70
        call increase_asteroid_spawn

        ld a, #4
        ld (level), a
        call draw_level_simple

        ld a, #lvl_up_timer
        ld (lvlup_timer), a

        ret

    not_level_4:
    cp #100
    jp nz, not_level_3                           ;;if score is higher then 100, level 3 -> faster enemies and asteroids
        ;; LEVEL 3

        ;; SPEED
        ld a, #8
        call increase_enemy_speed
        ld a, #11
        call increase_asteroid_speed

        ;;SPAWN
        ld a, #75
        call increase_enemy_spawn
        ld a, #100
        call increase_asteroid_spawn

        ld a, #3
        ld (level), a
        call draw_level_simple

        ld a, #lvl_up_timer
        ld (lvlup_timer), a

        ret
    not_level_3:
    cp #50
    jp nz, not_level_2                           ;;if score is higher then 30, level 2 -> enemies appear
        ;; LEVEL 2
        ld a, #2
        ld (level), a
        call draw_level_simple

        ld a, #lvl_up_timer
        ld (lvlup_timer), a
        ret
    not_level_2:                                ;;if score is higher then 0, level 1
    ;;LEVEL 1
ret

getLevel:
    ld a, (level)
ret

getHp:
    ld a, (hp)
ret