;;=====
;; Includes
;;=====
.include "cpctelera.h.s"
.include "intro.h.s"

.area _DATA

keyboard_timer: .db #0x06 				;; timer to scan the keyboard

.area _CODE
;;=====
;; Scan the whole keyboard and music every 6 interrupts
;;=====
isr:
	ex af, af' 							;;|
	exx 								;;|
	push af 							;;|
	push bc 							;;|
	push de 							;;|
	push hl 							;;\save all the registers

	ld a, (keyboard_timer) 				;; A=keyboard_timer
	dec a 								;; keyboard_timer--
	ld (keyboard_timer), a 				;; update keyboard_tiemr
	jr nz, return 						;; if keyboard_timer!=0 return

		call cpct_scanKeyboard_if_asm 	;; scan the keyboard
		ld a, #6 						;; restart keyboard_timer
		ld (keyboard_timer), a 			;; update keyboard_timer

	return:
	pop hl 								;;|
	pop de 								;;|
	pop bc 								;;|
	pop af 								;;|
	exx 								;;|
	ex af, af' 							;;\Recover the registers
ret

;;=====
;;Main program entry
;;=====
_main::
	;; Init Video
    ld sp, #0x7FFF
	call setVideoMode
	call initializeVideoMemory

	;; Set black border
	ld h, #0x14
	call setBorder

	;; Set InterruptHandler
	ld hl, #isr
	call cpct_setInterruptHandler_asm

	;; Intro screen
	call loadIntroScreen
	call toggleVideoMemory				;; change buffer and video memory
	call waitKey
ret